Loading...
Searching...
No Matches
BitVect Class Referenceabstract

Abstract base class for storing BitVectors. More...

`#include <BitVect.h>`

Inheritance diagram for BitVect:

## Public Member Functions

virtual | ~BitVect ()=0
virtual bool | setBit (const unsigned int which)=0
| sets a particular bit and returns its original value
virtual bool | unsetBit (const unsigned int which)=0
| unsets a particular bit and returns its original value
virtual bool | getBit (const unsigned int which) const =0
| returns the value of a particular bit
virtual unsigned int | getNumBits () const =0
| returns the number of bits (the length of the BitVect)
virtual unsigned int | getNumOnBits () const =0
| returns the number of on bits
virtual unsigned int | getNumOffBits () const =0
| returns the number of off bits
virtual void | getOnBits (IntVect &v) const =0
| replaces the contents of `v` with indices of our on bits
virtual void | clearBits ()=0
| clears (sets to off) all of our bits
void | initFromText (const char *data, const unsigned int dataLen, bool isBase64=false, bool allowOldFormat=false)
| initializes this BitVect from a pickle
virtual std::string | toString () const =0
| returns a serialized (pickled) version of this BitVect
virtual bool | operator[] (const unsigned int which) const =0
unsigned int | size () const

## Detailed Description

Abstract base class for storing BitVectors.

Definition at line 24 of file BitVect.h.

## Constructor & Destructor Documentation

## ~BitVect()

virtual BitVect::~BitVect | ( |  | ) |

pure virtual

## Member Function Documentation

## clearBits()

virtual void BitVect::clearBits | ( |  | ) |

pure virtual

clears (sets to off) all of our bits

Implemented in ExplicitBitVect, and SparseBitVect.

## getBit()

virtual bool BitVect::getBit | ( | const unsigned int | which | ) | const

pure virtual

returns the value of a particular bit

Implemented in ExplicitBitVect, and SparseBitVect.

## getNumBits()

virtual unsigned int BitVect::getNumBits | ( |  | ) | const

pure virtual

returns the number of bits (the length of the BitVect)

Implemented in ExplicitBitVect, and SparseBitVect.

Referenced by size().

## getNumOffBits()

virtual unsigned int BitVect::getNumOffBits | ( |  | ) | const

pure virtual

returns the number of off bits

Implemented in ExplicitBitVect, and SparseBitVect.

## getNumOnBits()

virtual unsigned int BitVect::getNumOnBits | ( |  | ) | const

pure virtual

returns the number of on bits

Implemented in ExplicitBitVect, and SparseBitVect.

## getOnBits()

virtual void BitVect::getOnBits | ( | IntVect & | v | ) | const

pure virtual

replaces the contents of `v` with indices of our on bits

Implemented in ExplicitBitVect, and SparseBitVect.

## initFromText()

void BitVect::initFromText | ( | const char * | data,
|  | const unsigned int | dataLen,
|  | bool | isBase64 = false,
|  | bool | allowOldFormat = false )

initializes this BitVect from a pickle

Parameters

  data | the raw pickle data
  dataLen | the length of `data`
  isBase64 | (optional) if this is set, `data` is assumed to be base64 encoded.
  allowOldFormat | (optional) allows a very old form of the BitVect representation to be recognized. This argument disables a large amount of error checking and it is strongly suggested that it not be used in client code.

## operator[]()

virtual bool BitVect::operator[] | ( | const unsigned int | which | ) | const

pure virtual

Implemented in ExplicitBitVect, and SparseBitVect.

## setBit()

virtual bool BitVect::setBit | ( | const unsigned int | which | ) |

pure virtual

sets a particular bit and returns its original value

Implemented in ExplicitBitVect, and SparseBitVect.

## size()

unsigned int BitVect::size | ( |  | ) | const

inline

Definition at line 62 of file BitVect.h.

References getNumBits().

Referenced by ExplicitBitVect::ExplicitBitVect(), ExplicitBitVect::ExplicitBitVect(), ExplicitBitVect::ExplicitBitVect(), and SparseBitVect::SparseBitVect().

## toString()

virtual std::string BitVect::toString | ( |  | ) | const

pure virtual

returns a serialized (pickled) version of this BitVect

Implemented in ExplicitBitVect, and SparseBitVect.

## unsetBit()

virtual bool BitVect::unsetBit | ( | const unsigned int | which | ) |

pure virtual

unsets a particular bit and returns its original value

Implemented in ExplicitBitVect, and SparseBitVect.

The documentation for this class was generated from the following file:

- BitVect.h